# coding: utf8
# author: zmej74
import urllib, sys, os, re, time, shutil
import xbmcaddon, xbmcplugin, xbmcgui, xbmc
import json as simplejson
import datetime,  commands


# Plugin constants
__addonname__ = "emupack"
__addonid__   = "plugin.program.emupack"
__addon__     = xbmcaddon.Addon(id=__addonid__)
__language__  = __addon__.getLocalizedString
__cwd__       = xbmc.translatePath( __addon__.getAddonInfo('path') )
__profile__   = xbmc.translatePath( __addon__.getAddonInfo('profile') )
__icondir__   = os.path.join( __cwd__,'resources','icons' )
# Shared resources
BASE_RESOURCE_PATH = os.path.join( __cwd__, 'resources', 'lib' )
sys.path.append(BASE_RESOURCE_PATH)
AUTO_START = __addon__.getSetting('AutomaticStart')

def RunDialog( ):
    lfile = open("/tmp/emupack.log", "w")
    import emu
    em = emu.emu_manager()
    em.log = lfile
    em.addonname = __addonname__
    em.addonid = __addonid__
    em.addon = __addon__   #xbmcaddon.Addon(id=__addonid__)
    em.cwd = __cwd__
    em.language = __language__    #__addon__.getLocalizedString
    em.loadEmus()
    menuList = []
    menuList.append( em.strlanguage( 30002,"Start EMU") )
    menuList.append( em.strlanguage( 30004, "Stop EMU") )
    menuList.append( em.strlanguage( 30003, "Restart EMU") )
    menuList.append( em.strlanguage( 30005, "Emu Info") )
    menuList.append( em.strlanguage( 11, "ECM Info" ) )
    menuList.append( em.strlanguage( 30012, "EMU Remove") )
    menuList.append( em.strlanguage( 30017, "Exit") )
    em.logout("Created main menu ")

   #Select Menu
    em.logout( em.strlanguage( 30001, "Main menu"))
    dialog = xbmcgui.Dialog()
    em.logout("Dialog created")
    flag = True
    while flag:
        selectIndex = dialog.select(  em.strlanguage( 30001, "Main menu"), menuList )
        em.logout( 'selectIndex=%d' %selectIndex )
        if selectIndex == 0:
            # submenu
            emuidList = []
            emunameList = []
            for oe in em.emus:
                if not oe.emu_running():
                    emuidList.append(oe.emu_id)
                    emunameList.append( oe.emu_name)
            subdialog = xbmcgui.Dialog()
            subIndex = subdialog.select( em.strlanguage(30015, "Emu list"), emunameList)
            em.logout( 'select Emu id to start = %s . Emu name = %s. Selected = %d' % (emuidList[subIndex], emunameList[subIndex],selectIndex ))
            if subIndex >= 0: em.startEmu(emuidList[subIndex])
        elif selectIndex == 1 :
            em.logout( 'Choice = Stop' )
            em.stopEmu()
        elif selectIndex == 2 :
            em.logout( 'Choice = Restart' )
            for oe in em.emus:
                if oe.emu_running():
                    em.stopEmu()
                    em.startEmu(oe.emu_id)
        elif selectIndex == 3 :
            em.logout( 'Choice = EMU Info' )
            em.infoEmu()
        elif selectIndex == 4 :
            em.logout( 'Choice = ECM Info' )
            em.infoEcm()
        elif selectIndex == 5 :
            em.logout( 'Choice = Remove' )
            em.removeEmu()
        #__addon__.openSettings()
        elif selectIndex == 6 or selectIndex == -1:
            flag = False
    lfile.close()
if __name__ == '__main__' :
    print 'EMU TEST'
    RunDialog( )


